Package ej.bon

## Class Timer

- java.lang.Object
- - ej.bon.Timer

-     public class Timer
      extends Object

  A facility for threads to schedule tasks for future execution in a background thread. Tasks may be scheduled for one-time execution, or for repeated execution at regular intervals.

  Corresponding to each Timer object is a single background thread that is used to execute all of the timer's tasks, sequentially. Timer tasks should complete quickly. If a timer task takes excessive time to complete, it "hogs" the timer's task execution thread. This can, in turn, delay the execution of subsequent tasks, which may "bunch up" and execute in rapid succession when (and if) the offending task finally completes.

  By default, the task execution thread does not run as a daemon thread, so it is capable of keeping an application from terminating. If a caller wants to terminate a timer's task execution thread, the caller should invoke the timer's cancel method.

  If a task execution terminates unexpectedly, the uncaughtException method is invoked on this task.

  This class is thread-safe: multiple threads can share a single Timer object without the need for external synchronization.

  This class does not offer real-time guarantees: it schedules tasks using the Object.wait(long) method. The resolution of the Timer is implementation and device dependent.

  Timers function only within a single VM and are canceled when the VM exits. When the VM is started no timers exist, they are created only by application request.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Timer()` | Creates a new timer.
    `Timer​(boolean automatic)` | Creates a new timer.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `cancel()` | Terminates this timer, discarding any currently scheduled tasks.
    `void` | `dump​(PrintStream s)` | Prints a status of this timer and its scheduled tasks to the specified print stream.
    `static Thread.UncaughtExceptionHandler` | `getDefaultUncaughtExceptionHandler()` | Gets the default registered handler for uncaught exceptions.
    `Thread.UncaughtExceptionHandler` | `getUncaughtExceptionHandler()` | Gets the specific handler for uncaught exceptions on this `Timer` instance.
    `void` | `run()` | Executes `TimerTask` scheduling.
    `void` | `schedule​(TimerTask task, long delay)` | Schedules the specified task for execution after the specified delay.
    `void` | `schedule​(TimerTask task, long delay, long period)` | Schedules the specified task for repeated fixed-delay execution, beginning after the specified delay.
    `void` | `schedule​(TimerTask task, Date time)` | Schedules the specified task for execution at the specified time.
    `void` | `schedule​(TimerTask task, Date firstTime, long period)` | Schedules the specified task for repeated fixed-delay execution, beginning at the specified time.
    `void` | `scheduleAtFixedRate​(TimerTask task, long delay, long period)` | Schedules the specified task for repeated fixed-rate execution, beginning after the specified delay.
    `void` | `scheduleAtFixedRate​(TimerTask task, Date firstTime, long period)` | Schedules the specified task for repeated fixed-rate execution, beginning at the specified time.
    `static void` | `setDefaultUncaughtExceptionHandler​(Thread.UncaughtExceptionHandler h)` | Sets the default handler for uncaught exceptions.
    `void` | `setUncaughtExceptionHandler​(Thread.UncaughtExceptionHandler h)` | Sets the specific handler for uncaught exceptions on this `Timer` instance.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Timer

          public Timer()

      Creates a new timer. The associated thread does not run as a daemon thread, which may prevent an application from terminating.

    - #### Timer

          public Timer​(boolean automatic)

      Creates a new timer.

      If the given boolean is `true`, a thread is created to execute this timer. The associated thread does not run as a daemon thread, which may prevent an application from terminating. All the `TimerTask` scheduled by the timer will be executed in the context of the associated thread.

      Otherwise an applicative thread must call the `run()` method in order to execute tasks scheduling.

      Parameters:
        `automatic` - If `true` a thread is created to run this timer, otherwise the application must manage this timer.
      See Also:
        `run()`

  - ### Method Detail

    - #### schedule

          public void schedule​(TimerTask task,
                               long delay)

      Schedules the specified task for execution after the specified delay.
      Parameters:
        `task` - task to be scheduled.
        `delay` - delay in milliseconds before task is to be executed. Note that the actual delay may be different from the amount requested since the resolution of the Timer is implementation and device dependent.
      Throws:
        `IllegalArgumentException` - if delay is negative, or delay + CurrentTime.get() is negative.
        `IllegalStateException` - if task was already scheduled or canceled, or timer was canceled.

    - #### schedule

          public void schedule​(TimerTask task,
                               Date time)

      Schedules the specified task for execution at the specified time. If the time is in the past, the task is scheduled for immediate execution.
      Parameters:
        `task` - task to be scheduled.
        `time` - time at which task is to be executed.
      Throws:
        `IllegalArgumentException` - if time.getTime() is negative.
        `IllegalStateException` - if task was already scheduled or canceled, timer was canceled, or timer thread terminated.

    - #### schedule

          public void schedule​(TimerTask task,
                               long delay,
                               long period)

      Schedules the specified task for repeated fixed-delay execution, beginning after the specified delay. Subsequent executions take place at approximately regular intervals separated by the specified period. Note that the actual delay may be different from the amount requested since the resolution of the Timer is implementation and device dependent.

      In fixed-delay execution, each execution is scheduled relative to the actual execution time of the previous execution. If an execution is delayed for any reason (such as garbage collection or other background activity), subsequent executions will be delayed as well. In the long run, the frequency of execution will generally be slightly lower than the reciprocal of the specified period (assuming the system clock underlying Object.wait(long) is accurate).

      Fixed-delay execution is appropriate for recurring activities that require "smoothness." In other words, it is appropriate for activities where it is more important to keep the frequency accurate in the short run than in the long run. This includes most animation tasks, such as blinking a cursor at regular intervals. It also includes tasks wherein regular activity is performed in response to human input, such as automatically repeating a character as long as a key is held down.

      Parameters:
        `task` - task to be scheduled.
        `delay` - delay in milliseconds before task is to be executed. Note that the actual delay may be different from the amount requested since the resolution of the Timer is implementation and device dependent.
        `period` - time in milliseconds between successive task executions.
      Throws:
        `IllegalArgumentException` - if delay is negative, or delay + CurrentTime.get() is negative.
        `IllegalStateException` - if task was already scheduled or canceled, timer was canceled, or timer thread terminated.

    - #### schedule

          public void schedule​(TimerTask task,
                               Date firstTime,
                               long period)

      Schedules the specified task for repeated fixed-delay execution, beginning at the specified time. Subsequent executions take place at approximately regular intervals, separated by the specified period.

      In fixed-delay execution, each execution is scheduled relative to the actual execution time of the previous execution. If an execution is delayed for any reason (such as garbage collection or other background activity), subsequent executions will be delayed as well. In the long run, the frequency of execution will generally be slightly lower than the reciprocal of the specified period (assuming the system clock underlying Object.wait(long) is accurate).

      Fixed-delay execution is appropriate for recurring activities that require "smoothness." In other words, it is appropriate for activities where it is more important to keep the frequency accurate in the short run than in the long run. This includes most animation tasks, such as blinking a cursor at regular intervals. It also includes tasks wherein regular activity is performed in response to human input, such as automatically repeating a character as long as a key is held down.

      Parameters:
        `task` - task to be scheduled.
        `firstTime` - First time at which task is to be executed.
        `period` - time in milliseconds between successive task executions.
      Throws:
        `IllegalArgumentException` - if time.getTime() is negative.
        `IllegalStateException` - if task was already scheduled or canceled, timer was canceled, or timer thread terminated.

    - #### scheduleAtFixedRate

          public void scheduleAtFixedRate​(TimerTask task,
                                          long delay,
                                          long period)

      Schedules the specified task for repeated fixed-rate execution, beginning after the specified delay. Subsequent executions take place at approximately regular intervals, separated by the specified period.

      In fixed-rate execution, each execution is scheduled relative to the scheduled execution time of the initial execution. If an execution is delayed for any reason (such as garbage collection or other background activity), two or more executions will occur in rapid succession to "catch up." In the long run, the frequency of execution will be exactly the reciprocal of the specified period (assuming the system clock underlying Object.wait(long) is accurate).

      Fixed-rate execution is appropriate for recurring activities that are sensitive to absolute time, such as ringing a chime every hour on the hour, or running scheduled maintenance every day at a particular time. It is also appropriate for for recurring activities where the total time to perform a fixed number of executions is important, such as a countdown timer that ticks once every second for ten seconds. Finally, fixed-rate execution is appropriate for scheduling multiple repeating timer tasks that must remain synchronized with respect to one another.

      Parameters:
        `task` - task to be scheduled.
        `delay` - delay in milliseconds before task is to be executed. Note that the actual delay may be different from the amount requested since the resolution of the Timer is implementation and device dependent.
        `period` - time in milliseconds between successive task executions.
      Throws:
        `IllegalArgumentException` - if delay is negative, or delay + CurrentTime.get() is negative.
        `IllegalStateException` - if task was already scheduled or canceled, timer was canceled, or timer thread terminated.

    - #### scheduleAtFixedRate

          public void scheduleAtFixedRate​(TimerTask task,
                                          Date firstTime,
                                          long period)

      Schedules the specified task for repeated fixed-rate execution, beginning at the specified time. Subsequent executions take place at approximately regular intervals, separated by the specified period.

      In fixed-rate execution, each execution is scheduled relative to the scheduled execution time of the initial execution. If an execution is delayed for any reason (such as garbage collection or other background activity), two or more executions will occur in rapid succession to "catch up." In the long run, the frequency of execution will be exactly the reciprocal of the specified period (assuming the system clock underlying Object.wait(long) is accurate).

      Fixed-rate execution is appropriate for recurring activities that are sensitive to absolute time, such as ringing a chime every hour on the hour, or running scheduled maintenance every day at a particular time. It is also appropriate for for recurring activities where the total time to perform a fixed number of executions is important, such as a countdown timer that ticks once every second for ten seconds. Finally, fixed-rate execution is appropriate for scheduling multiple repeating timer tasks that must remain synchronized with respect to one another.

      Parameters:
        `task` - task to be scheduled.
        `firstTime` - first time at which task is to be executed.
        `period` - time in milliseconds between successive task executions.
      Throws:
        `IllegalArgumentException` - if time.getTime() is negative.
        `IllegalStateException` - if task was already scheduled or canceled, timer was canceled, or timer thread terminated.

    - #### cancel

          public void cancel()

      Terminates this timer, discarding any currently scheduled tasks. Does not interfere with a currently executing task (if it exists). Once a timer has been terminated, its execution thread terminates gracefully, and no more tasks may be scheduled on it. Note that calling this method from within the run method of a timer task that was invoked by this timer absolutely guarantees that the ongoing task execution is the last task execution that will ever be performed by this timer.

    - #### run

          public void run()

      Executes `TimerTask` scheduling. This method must be called only for `Timer` that are not automatic (i.e. no thread is automatically started at `Timer` creation). This is the current thread that executes the `Timer` scheduling loop.

      This method can be called once on this `Timer` and returns only if `cancel()` is called.

      Throws:
        `IllegalStateException` - if this timer is already running or canceled.

    - #### setDefaultUncaughtExceptionHandler

          public static void setDefaultUncaughtExceptionHandler​(@Nullable
                                                                Thread.UncaughtExceptionHandler h)

      Sets the default handler for uncaught exceptions.
      Parameters:
        `h` - the new default handler, or `null` to remove the default `Timer` class handler.
      Throws:
        `SecurityException` - if a security manager exists and it denies ``RuntimePermission` ("setDefaultUncaughtExceptionHandler")`
      See Also:
        `setUncaughtExceptionHandler(Thread.UncaughtExceptionHandler)`, `TimerTask.uncaughtException(Timer, Throwable)`

    - #### getDefaultUncaughtExceptionHandler

          @Nullable
          public static Thread.UncaughtExceptionHandler getDefaultUncaughtExceptionHandler()

      Gets the default registered handler for uncaught exceptions.
      Returns:
        the default handler, or `null` if there is no default handler registered.
      See Also:
        `setDefaultUncaughtExceptionHandler(Thread.UncaughtExceptionHandler)`, `TimerTask.uncaughtException(Timer, Throwable)`

    - #### setUncaughtExceptionHandler

          public void setUncaughtExceptionHandler​(Thread.UncaughtExceptionHandler h)

      Sets the specific handler for uncaught exceptions on this `Timer` instance.
      Parameters:
        `h` - the new handler, or `null` to remove the specific `Timer` handler.
      See Also:
        `setDefaultUncaughtExceptionHandler(Thread.UncaughtExceptionHandler)`, `TimerTask.uncaughtException(Timer, Throwable)`

    - #### getUncaughtExceptionHandler

          @Nullable
          public Thread.UncaughtExceptionHandler getUncaughtExceptionHandler()

      Gets the specific handler for uncaught exceptions on this `Timer` instance.
      Returns:
        the handler, or `null` if there no registered handler.
      See Also:
        `TimerTask.uncaughtException(Timer, Throwable)`

    - #### dump

          public void dump​(PrintStream s)

      Prints a status of this timer and its scheduled tasks to the specified print stream. This method is used only for debugging.
      Parameters:
        `s` - `PrintStream` to use for output.